## iir1 1.9.4+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8.0)

project(iir VERSION 1.9.4 LANGUAGES CXX)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})

include(GNUInstallDirs)

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()

option(IIR1_NO_EXCEPTIONS "Disable exception handling" OFF)

option(IIR1_INSTALL_STATIC "Install static library" ON)

if(CMAKE_PROJECT_NAME STREQUAL PROJECT_NAME)
  set(IIR1_BUILD_TESTING_DEFAULT ON)
else()
  set(IIR1_BUILD_TESTING_DEFAULT OFF)
endif()

option(IIR1_BUILD_TESTING "Build tests" ${IIR1_BUILD_TESTING_DEFAULT})
if(IIR1_BUILD_TESTING)
  enable_testing()
  add_subdirectory(test)
endif()

option(IIR1_BUILD_DEMO "Build demo" ON)
if(IIR1_BUILD_DEMO)
  add_subdirectory(demo)
endif()

if (MSVC)
  add_compile_options(/W4)
else()
  add_compile_options(-Wall -pedantic)
endif()

set(LIBSRC
  iir/Biquad.cpp
  iir/Butterworth.cpp
  iir/Cascade.cpp
  iir/ChebyshevI.cpp
  iir/ChebyshevII.cpp
  iir/Custom.cpp
  iir/PoleFilter.cpp
  iir/RBJ.cpp)

set(LIBINCLUDE
  iir/Biquad.h
  iir/Butterworth.h
  iir/Cascade.h
  iir/ChebyshevI.h
  iir/ChebyshevII.h
  iir/Common.h
  iir/Custom.h
  iir/Layout.h
  iir/MathSupplement.h
  iir/PoleFilter.h
  iir/RBJ.h
  iir/State.h
  iir/Types.h)

add_library(iir SHARED ${LIBSRC})
add_library(iir::iir ALIAS iir)

target_compile_features(iir PUBLIC cxx_std_11)

target_include_directories(iir
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>      # for Iir.h
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/iir>  # everything else
)

if(IIR1_NO_EXCEPTIONS)
    target_compile_definitions(iir PUBLIC "IIR1_NO_EXCEPTIONS")
endif()

set_target_properties(iir PROPERTIES
  SOVERSION 1
  VERSION ${PROJECT_VERSION}
  PUBLIC_HEADER Iir.h
  PRIVATE_HEADER "${LIBINCLUDE}")

install(TARGETS iir EXPORT iir-targets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  PRIVATE_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/iir)

include(JoinPaths)

join_paths(includedir_for_pc_file "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
join_paths(libdir_for_pc_file "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")

configure_file(iir.pc.in iir.pc @ONLY)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/iir.pc"
  DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig/")

add_library(iir_static STATIC ${LIBSRC})
add_library(iir::iir_static ALIAS iir_static)

target_compile_features(iir_static PUBLIC cxx_std_11)

target_include_directories(iir_static
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>      # for Iir.h
  PRIVATE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/iir>  # everything else
)

if(IIR1_NO_EXCEPTIONS)
    target_compile_definitions(iir_static PUBLIC "IIR1_NO_EXCEPTIONS")
endif()

set_target_properties(iir_static PROPERTIES
  POSITION_INDEPENDENT_CODE TRUE
  VERSION ${PROJECT_VERSION}
  PUBLIC_HEADER Iir.h
  PRIVATE_HEADER "${LIBINCLUDE}")

if(IIR1_INSTALL_STATIC)
  install(TARGETS iir_static EXPORT iir-targets
    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
    PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
    PRIVATE_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/iir)
endif()

install(EXPORT iir-targets
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/iir
  NAMESPACE iir::
  FILE iirTargets.cmake
)

include(CMakePackageConfigHelpers)

configure_package_config_file(${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in
  "${CMAKE_CURRENT_BINARY_DIR}/iirConfig.cmake"
  INSTALL_DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/iir"
  NO_SET_AND_CHECK_MACRO
  NO_CHECK_REQUIRED_COMPONENTS_MACRO
  )

write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/iirConfigVersion.cmake"
  VERSION "${iir_VERSION_MAJOR}.${iir_VERSION_MINOR}"
  COMPATIBILITY AnyNewerVersion
)

install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/iirConfig.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/iirConfigVersion.cmake
  DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/iir
  )

=== debian/changelog ===
iir1 (1.9.4+dfsg-3) unstable; urgency=medium

  * Fix the optional symbol declarations.

 -- Stephen Kitt <skitt@debian.org>  Thu, 04 Jul 2024 08:12:04 +0200

iir1 (1.9.4+dfsg-2) unstable; urgency=medium

  * Add LayoutBase::addPoleZeroConjugatePairs to the list of symbols; it
    is exported at least on armhf.
  * Mark LayoutBase::add and the std::vector _M_realloc_insert as
    optional; g++ 14 no longer exports them. Closes: #1075088.
  * Standards-Version 4.7.0, no change required.

 -- Stephen Kitt <skitt@debian.org>  Wed, 03 Jul 2024 20:21:14 +0200

iir1 (1.9.4+dfsg-1) unstable; urgency=medium

  * Source-only upload after NEW.

 -- Stephen Kitt <skitt@debian.org>  Tue, 16 Apr 2024 21:46:22 +0200

iir1 (1.9.4+dfsg-1~exp1) unstable; urgency=medium

  * Initial release. Closes: #1065378.

 -- Stephen Kitt <skitt@debian.org>  Sun, 03 Mar 2024 16:38:53 +0100

## iir1 1.9.5+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.8.0)
 
-project(iir VERSION 1.9.4 LANGUAGES CXX)
+project(iir VERSION 1.9.5 LANGUAGES CXX)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})

=== demo/CMakeLists.txt ===
project(IIRDemo)

cmake_minimum_required(VERSION 3.8.0)

if (MSVC)
    add_compile_options(/W4)
  else()
    add_compile_options(-Wall)
endif()

add_executable (iirdemo iirdemo.cpp)
target_link_libraries(iirdemo iir_static)
target_compile_features(iirdemo PRIVATE cxx_std_11)

add_executable (rbj_update rbj_update.cpp)
target_link_libraries(rbj_update iir_static)
target_compile_features(rbj_update PRIVATE cxx_std_11)

add_executable (ecg50hzfilt ecg50hzfilt.cpp)
target_link_libraries(ecg50hzfilt iir_static)
target_compile_features(ecg50hzfilt PRIVATE cxx_std_11)

=== debian/changelog ===
iir1 (1.9.5+dfsg-1) unstable; urgency=medium

  * New upstream release.

 -- Stephen Kitt <skitt@debian.org>  Fri, 16 Aug 2024 17:12:55 +0200

=== debian/control ===
Source: iir1
Maintainer: Stephen Kitt <skitt@debian.org>
Section: libs
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 cmake,
Build-Depends-Indep:
 doxygen-latex,
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian/iir1
Vcs-Git: https://salsa.debian.org/debian/iir1.git
Homepage: https://www.berndporr.me.uk/iir/
Rules-Requires-Root: no

Package: libiir-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libiir1 (= ${binary:Version}),
         ${misc:Depends}
Suggests: libiir1-doc
Description: DSP IIR realtime filter library - development files
 libiir is an infinite impulse response library implementing
 Butterworth, RBJ, and Chebychev filters. The filter processes data
 sample by sample for realtime processing.
 .
 This package contains the files required to build software using
 libiir.

Package: libiir-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}
Description: DSP IIR realtime filter library - documentation
 libiir is an infinite impulse response library implementing
 Butterworth, RBJ, and Chebychev filters. The filter processes data
 sample by sample for realtime processing.
 .
 This package contains the documentation for developers wishing to
 build software using libiir.

Package: libiir1
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: DSP IIR realtime filter library
 libiir is an infinite impulse response library implementing
 Butterworth, RBJ, and Chebychev filters. The filter processes data
 sample by sample for realtime processing.
 .
 This package contains the files required to run software using
 libiir.

## iir1 1.10.0%2Bdfsg

=== debian/changelog ===
iir1 (1.10.0+dfsg-4) unstable; urgency=medium

  * Disable the static library entirely, instead of building it and not
    shipping it, which results in a dysfunctional CMake configuration
    file. Closes: #1125282.
  * Drop the versioned dependency on doxygen-latex: all versions of
    doxygen-latex currently available in Debian build the documentation
    correctly.
  * Drop “Priority: optional” since it’s now the default.
  * Standards-Version 4.7.3, no further change required.
  * Update debian/watch to version 5.

 -- Stephen Kitt <skitt@debian.org>  Mon, 12 Jan 2026 18:42:25 +0100

iir1 (1.10.0+dfsg-3) unstable; urgency=medium

  * Drop the doxygen fix, which is no longer needed with doxygen 1.15.0
    and actually breaks the build with that version. Closes: #1122429.
  * Drop “Rules-Requires-Root: no” since it’s now the default.

 -- Stephen Kitt <skitt@debian.org>  Thu, 11 Dec 2025 18:12:36 +0100

iir1 (1.10.0+dfsg-2) unstable; urgency=medium

  * Apply the Doxygen workaround for LaTeX errors when building the PDF
    documentation.

 -- Stephen Kitt <skitt@debian.org>  Fri, 29 Aug 2025 13:17:46 +0200

iir1 (1.10.0+dfsg-1) unstable; urgency=medium

  * New upstream release. The upstream changelog mentions a change in an
    exported symbol, but the only change was in a header file and the
    exported symbols aren’t affected.
  * Standards-Version 4.7.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Fri, 29 Aug 2025 08:52:46 +0200

## iir1 1.10.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 cmake_minimum_required(VERSION 3.8.0)
 
-project(iir VERSION 1.9.5 LANGUAGES CXX)
+project(iir VERSION 1.10.0 LANGUAGES CXX)
 
 set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_CURRENT_SOURCE_DIR})

=== demo/CMakeLists.txt ===
--- 
+++ 
@@ -8,9 +8,19 @@
     add_compile_options(-Wall)
 endif()
 
+# Copy scripts and data to build dir	
+function(copy_demo_file TARGET FILE)
+    add_custom_command(TARGET ${TARGET} POST_BUILD
+        COMMAND ${CMAKE_COMMAND} -E copy
+            "${CMAKE_CURRENT_SOURCE_DIR}/${FILE}"
+            "$<TARGET_FILE_DIR:${TARGET}>/${FILE}"
+    )
+endfunction()
+
 add_executable (iirdemo iirdemo.cpp)
 target_link_libraries(iirdemo iir_static)
 target_compile_features(iirdemo PRIVATE cxx_std_11)
+copy_demo_file(iirdemo plot_impulse_fresponse.py)
 
 add_executable (rbj_update rbj_update.cpp)
 target_link_libraries(rbj_update iir_static)
@@ -19,3 +29,5 @@
 add_executable (ecg50hzfilt ecg50hzfilt.cpp)
 target_link_libraries(ecg50hzfilt iir_static)
 target_compile_features(ecg50hzfilt PRIVATE cxx_std_11)
+copy_demo_file(ecg50hzfilt plot_ecg_filt.py)
+copy_demo_file(ecg50hzfilt ecg50hz.dat)

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,15 @@
 Source: iir1
 Maintainer: Stephen Kitt <skitt@debian.org>
 Section: libs
-Priority: optional
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
 Build-Depends-Indep:
  doxygen-latex,
-Standards-Version: 4.7.0
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/iir1
 Vcs-Git: https://salsa.debian.org/debian/iir1.git
 Homepage: https://www.berndporr.me.uk/iir/
-Rules-Requires-Root: no
 
 Package: libiir-dev
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DIIR1_INSTALL_STATIC=OFF

override_dh_auto_build-indep:
	doxygen
	make -C docs/pdf

override_dh_auto_test-indep:

override_dh_auto_install-indep:

=== debian/watch ===
Version: 5

Template: Github
Dversionmangle: s/\+dfsg$//
Owner: berndporr
Project: iir1
Repacksuffix: +dfsg
